Attribute VB_Name = "q_QuidoDllMap"
'  QuidoStackDll - Mapovn funkc z knihovny QuidoStackDll.dll
'
'  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
'  Autor     :  Martin Zmenk zamecnik@papouch.com
'
'  Poznmky  : k pouit funkc jsou poteba knihovny QuidoStackDll.dll a CommIntfDll.dll,
'              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll
'  Upozornn: veker parametry Index, a to i v ppad vstup a vstup quida, jsou slovny od 0 !!!

Option Explicit
Const QDLLName = "QuidoStackDll.dll"

'identifikace udlost (event) vyvolanch Quidem. pro zasln udlost registrujet jejich pjem pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications
Public Const qev_Base = 511
Public Const qev_InputsChange = qev_Base + 1 ' //zmna vstup - obecn oznm, z byla zaznamenna zmna nkterho vstupu
Public Const qev_OutputsChange = qev_Base + 2 ' //zmna vstup - oznm, e byl znnn nkter vstup
Public Const qev_InputChange = qev_Base + 3 ' //zmna vstupu - oznm, e byl zmnn jednotliv vstup (oznamuje kad vstup zvl᚝)
Public Const qev_OutputChange = qev_Base + 4 ' //zmna vstupu - oznm, e byla zaznamenna zmna jednotlivho vstupu
Public Const qev_CIOpen = qev_Base + 5 ' //-- oteven komunikanho kanlu quida
Public Const qev_CIClose = qev_Base + 6 ' //-- uzaven komunikanho kanlu quida


Public Declare Function DllInfo Lib "QuidoStackDll.dll" () As String '-- vrac informan text o knihovn

Public Declare Function qHandlesCount Lib "QuidoStackDll.dll" () As Long '-- vrac poet vytvoench Quid (funkcemi qCreateQuido...), -1 = chyba
Public Declare Function qHandleByIndex Lib "QuidoStackDll.dll" (ByVal Index As Long) As Long '-- vrac handle na Quido podle indexu (0..qHandlesCount-1), 0 = neplatn handle
Public Declare Function ciHandlesCount Lib "QuidoStackDll.dll" () As Long '-- vrac poet vytvoench komunikanch rozhran (a ji spolen s Quidem nebo zvl᚝ v QuidoStackDll.dll), -1=chyba
Public Declare Function ciHandleByIndex Lib "QuidoStackDll.dll" (ByVal Index As Long) As Long '-- vrac handle na komunikan rozhran podle indexu (0..ciHandlesCount-1), 0=chyba

Public Declare Function qCreateQuido Lib "QuidoStackDll.dll" (ByVal ConnectionString As String, ByVal devicestring As String) As Long
    '-- vytvoi objekt Quida. vrac handle vytvoenho objektu Quida, 0 = nepovedlo se vytvoit
    '--       connection string je etzec pro vytvoen komunikanho rozhrann, uruje komunikan kanl a jeho nastaven (sriov port, tcp, udp, nebo ftd_usb)
    '--       devicestring specifikuje parametry zazen Quido (adresu. v ppad e je na komunikanm kanlu pouze jedno zazen, lze zadat univerzln adresu $FE)
    '   Tvorba connectionstringu  as  jsou to hodnoty ve tvaru "parametr=hodnota" oddLenghty stednkem. uruj typ pipojen
    '          nejdleitjm parametrem je "provider", uruje typ komunikanho kanlu. me to bt SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB
    '          kad kanl pak me mt dal parametry. SERIAL_PORT (comport=slo portu,baudrate=rychlost - nemus bt zadno), TCP_CLIENT(host=ip adresa zazen,port=tcp port zazen), UDP_CLIENT(stejn jako TCP), FTD_USB(index=poadov slo zazen, nebo device=st nzvu zazen, nebo serial_number=sriov slo zazen, nebo vid=vid,pid=pid, nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB
    '          pklady as  "provider=SERIAL_PORT,comport=1", "provider=TCP_CLIENT,host=192.168.1.254,port=10001", "provider=UDP_CLIENT,host=192.168.1.254,port=10001", "provider=FTD_USB,device=Quido"
    '   Tvorba devicestringu as  p. "addr=12", "addr=$FE" ($ - znamen slo je zadno v hexa, $FE=univerzln adresa)

Public Declare Function qCreateQuidoCI Lib "QuidoStackDll.dll" (ByVal ciHandle As Long, ByVal devicestring As String) As Long '-- Vytvo objekt Quida, pouije se komunikan rozhrann ji explicitn vytvoen v CommIntfDll (ciHandle)
Public Declare Function qCreateQuidoEx Lib "QuidoStackDll.dll" (ByVal ConnectionString As String, ByVal devicestring As String, ByVal ciEventType As Long) As Long '-- umouje specifikovat zpsob voln udlost mezi komunikanm rozhrannm a objektem quida  - ciEventType (0 - sendmessage, 1 - callback, 2 - postmessage). nedoporuuje se pouvat, pokud k tomu nen dvod
Public Declare Function qCreateQuidoCIEx Lib "QuidoStackDll.dll" (ByVal ciHandle As Long, ByVal devicestring As String, ByVal ciEventType As Long) As Long '-- pouit explicitn vytvoenho komunikanho rozhrann, specifikace zpsobu voln udlost

Public Declare Function qGetQuidoCIHandle Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long '-- vrt handle komunikanho rozhran pipojenmu ke Quidu

Public Declare Function qOpen Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- oteve komunikan kanl Quida (oteve port, nave tcp spojen, ... podle typu komunikanho rozhran, nutno pro komunikaci se zazenm, vrt 0 pokud OK, chybov kd v opanm ppad (plat obecn pro nvratov typ long (long))
Public Declare Function qClose Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- zave komunikan kanl Quida, vrt 0 pokud OK, chybov kd v opanm ppad
Public Declare Function qIsOpened Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Opened As Long) As Long '-- zjist, zda je komunikan kanl quida oteven
Public Declare Function qReleaseQuido Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- zru objekt quida (vetn pslunho komunikanho rozhran - pokud nen zadno pi vytvoen explicitn pomoc handlu - qCreateQuidoCI)

Public Declare Function qInputsCount Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- vrt poet vstup Quida, -1=chyba
Public Declare Function qOutputsCount Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- vrt poet vstup Quida, -1=chyba
Public Declare Function qInputCountersCount Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- vrt poet ta vstup, -1=chyba, standardn poet ta vstup=poet vstup, maximln vak 60

Public Declare Function qInputStateByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef State As Long) As Long '-- vrt do State stav vstupu podle indexu (0..poet vstup-1) (true=je na vstupu napt, false=neni), nvratov hodnota as  0-ok, jinak chyba
Public Declare Function qOutputStateByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef State As Long) As Long '-- vrt do State stav vstupu podle indexu (0..poet vstup-1)  (true=je na vstupu napt, false=neni), nvratov hodnota as  0-ok, jinak chyba
Public Declare Function qInputCounterValueByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef Value As Long, ByVal NullCounter As Long) As Long '-- vrt do Value hodnotu tae vstupu podle indexu (0..poet ta-1), pokud je NullCounter true, ta se zhy vynuluje

Public Declare Function qGetInputs Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Inputs, ByRef Lenght As Long) As Long   '-- vrt v poli stav vech vstup. do inputs je teba zadat ukazatel na pole alokovan na (poet vstup) byt, do Lenght je teba zadat velikost tohoto pole, pi pouit klasickho pole v delphi (array of boolean) je teba zadat ukazatel na prvn prvek pole (@pole[0]),
             '---  pokud je ve v podku, od Inputs se vypln stavy vstup, do Lenght se vypln aktuln velikost pole a nvratov hodnota je 0
             '---  pokud se do Inputs zad nil, do Lenght se vypln potebn velikost pole a nvratov hodnota je 0
             '---  pokud se vyskytne chyba (stav vstup nelze zjistit, nebo zadan velikost Lenght je nedostaten), nvratov hodnota je chybov kd <> 0
Public Declare Function qGetOutputs Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Outputs, ByRef Lenght As Long) As Long '-- vrt v poli stav vech vstup. princip jako u qGetInputs

Public Declare Function qSetOutput Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByVal State As Long) As Long '-- Nastav stav vstupu Quida podle indexu (State as true=sepnout,false=rozepnout). pokud je nvratov hodnota 0=OK, jinach chyba
Public Declare Function qSetOutputTimered Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByVal State As Boolean, ByVal Time As Long) As Long '-- Nastav stav vstupu na urit as (Time=as ve vteinch).pokud je nvratov hodnota 0=OK, jinach chyba

Public Declare Function qSetOutputs Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Outputs, ByVal Lenght As Long) As Long '-- Nastav najednou stav vech vstup. do outputs se zad pole booLenght (1 bytovch). Lenght uruje velikost pole, pokud je nvratov hodnota 0=OK, jinach chyba

Public Declare Function qGetRecentInputsState Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Inputs, ByRef Lenght As Long) As Long  '-- vrt v poli naposledy znm stav vstup - stejn jako qGetInputs, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav. vhodn nap. po udlosti qev_InputsChange.
Public Declare Function qGetRecentOutputsState Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Outputs, ByRef Lenght As Long) As Long '-- vrt v poli naposledy znm stav vstup - procuje jako qGetRecentInputsState

Public Declare Function qGetRecentInputByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef State As Long) As Long  '-- vrt naposledy znm stav vstupu Quida podle Indexu (jako qGetInputStateByIndex, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav
Public Declare Function qGetRecentOutputByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef State As Long) As Long '-- vrt naposledy znm stav vstupu Quida podle Indexu. pracuje jako qGetRecentInputByIndex
Public Declare Function qGetRecentInputCounterByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef Value As Long) As Long '-- vrt naposledy znm stav tae vstupu Quida podle Indexu.
Public Declare Function qGetRecentCounterSettingByIndex Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef Rising As Long, Falling As Long) As Long  '-- vrt naposledy znm stav nastaven vstupu Quida podle Indexu

Public Declare Function qRefreshRecentStates Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Inputs As Long, ByVal Outputs As Long, ByVal Counters As Long, ByVal CounterSettings As Long) As Long
'qCheckInputsState Lib "QuidoStackDll.dll" (qHandle as long, Wait as long) as long '-- zjist ze zazen stavy vstup. ty jsou pak k dispozici pomoc funkc qGetRecentInputsstate a qGetRecentInputByIndex
'qCheckOutputsState Lib "QuidoStackDll.dll" (qHandle as long, Wait as long) as long '-- zjist ze zazen stavy vstup. ty jou pak k dispozici pomoc funkc qGetRecentOutputsState a qGetRecentOutputByIndex

Public Declare Function qGetAutoNotify Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Value As Long) As Long  '-- vrt do Value zda je aktivovno automatick oznamovn zmny stavu vstup (pokud je registrovno oznamovn pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications,
Public Declare Function qSetAutoNotify Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Value As Long) As Long  '-- nastav nebo zru automatick oznamovn zmny stavu vstup (true=nastavit, false=zruit)

Public Declare Function qSetCounterSetting Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByVal Rising As Long, ByVal Falling As Long) As Long  '-- Nastaven tae (na kter hrany signlu se inkrementuje - rising=nbn, falling=sestupn)
Public Declare Function qGetCounterSetting Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Index As Long, ByRef Rising As Long, ByRef Falling As Long) As Long  '-- Zjitn nastaven tae

Public Declare Function qRegisterMsgNotifications Lib "QuidoStackDll.dll" (ByVal Handle As Long, ByVal WHandle As Long, ByVal Msg As Long, ByVal blocking As Long) As Long '-- registruje zasln udlost Quida pomoc Windows zprv (Oteven a zaven komunikanho kanlu, zmny stav vstup, ...). zadv se long okna, kter zprvu pijm a identifikaci zprvy, kter je zaslna. v parametru zprvy WParam je zasln handle Quida, kter ji zasl, v LParamLo je zasln typ udlosti, LParamHi ppadn dodaten parametr
Public Declare Function qUnregisterMsgNotifications Lib "QuidoStackDll.dll" (ByVal Handle As Long) As Long   '-- ru zasln udlost Quida pomoc Windows zprv
Public Declare Function qRegisterCallBackNotifications Lib "QuidoStackDll.dll" (ByVal Handle As Long, ByVal CallBackEntryPoint As Long, ByVal CallBackID As Long) As Long '-- registruje zasln udlost Quida pomoc voln callbackov funkce formtu longnghtotificationEvent
Public Declare Function qUnregisterCallBackNotifications Lib "QuidoStackDll.dll" (ByVal Handle As Long) As Long '-- ru zasln udlost Quida pomoc callbackov funkce

Public Declare Function qInfo Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Info As String, ByRef Lenght As Long) As Long  '-- vrac textovou identifikaci zazen (Quida)
Public Declare Function qReset Lib "QuidoStackDll.dll" (ByVal qHandle As Long) As Long  '-- Resetovn zazen
Public Declare Function qGetAddress Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Addr As Long) As Long '-- zjitn adresy zazen
Public Declare Function qSetAddress Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef Addr As Long) As Long '-- nastaven adresy zazen (0-253)
Public Declare Function qGetUserData Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal UserData As String, ByRef Lenght As Long) As Long '-- zskn uvatelskch dat (16 byt)
Public Declare Function qSetUserData Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal UserData As String, ByVal Lenght As Long) As Long  '-- nastaven uivatelskch dat (16 byt)
Public Declare Function qGetFactoryInfo Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByRef ProductID As Long, ByRef SerialNumber As Long, ByRef FactoryData As Long) As Long '-- zjskn vrobnch dat (sriovho sla,..) zazen

Public Declare Function qSndRcvSpin97 Lib "QuidoStackDll.dll" (ByVal qHandle As Long, ByVal Inst As Byte, ByVal Data As String, ByVal DataLenght As Long, _
                  ByRef RcvAck As Byte, ByVal RcvData As String, ByRef RcvDataLenght As Long, ByVal MaxTimeOut As Long) As Long
                  '-- Zale spinel paket, zadan instrukc Inst a daty Data (velikosti DataLenght) a ek na odpov (maximln MaxTimeOut milisekund)
                  ' Pokud pijde odpov, nvratov hodnota je 0, do bufferu RcvData o velikosti RcvDataLenght se zapou vrcen data spinel paketu a v RcvDataLenght se vrt aktuln velikost dat.
                  ' RcvAck vrt kd odpovdi (0 = OK)
                  ' Pokud se paket neodele, nebo se nevrt odpov, nebo vznikne jin chyba, nvratov hodnota <> 0

Public Declare Function ciGetConnectionStringDlg Lib "QuidoStackDll.dll" (ByVal OutConnStr As String, ByRef Lenght As Long, ByRef OKReturn As Long, ByVal DefaultValue As String, ByVal Caption As String) As Long '-- Vyvol dialogov okno pro vytvoen pipojovacho etzce (connection string). Vrac hodnotu<>0, pokud nastala chyba
                        '-- OutConStr as sem je vrcen connectionstring, Lenght as velikost bufferu OutConStr, OKReturn as vrceno true, pokut bylo stisknuto OK, DefaultValue as ppadn pednastaven vchozho connectionstringu, Caption as  vlastn titulek dialogu

Public Declare Function LastError Lib "QuidoStackDll.dll" () As Long '-- vrt chybov kd naposledy volan funkce. 0=funkce probhla v podku
Public Declare Function LastErrorText Lib "QuidoStackDll.dll" (ByVal Text As String, ByRef Size As Long) As Long '-- vrt text chyby naposledy volan funkce

